#include "media.h"

char *get_namespace(){
        return "xmlns=\"www.abo.fi\"";
}


/**
 * @brief Register ontology.
 *
 * It creates all structures, such as classes and properties. Use it firs in your propgramm.
 */
void register_ontology()
{    
    list_t *tmp_node = NULL;    

#if INCLUDE_PROPERTY_DEVICENAME

PROPERTY_DEVICENAME =  (property_t *) malloc(sizeof(property_t));
PROPERTY_DEVICENAME->name = strdup("DeviceName");
PROPERTY_DEVICENAME->about = strdup("#DeviceName");
//PROPERTY_DEVICENAME->range = "http://www.w3.org/2001/XMLSchema#string"; //getRange
PROPERTY_DEVICENAME->domain = strdup("#Device"); 
PROPERTY_DEVICENAME->maxcardinality = -1;
PROPERTY_DEVICENAME->mincardinality = -1;
PROPERTY_DEVICENAME->subpropertyof = NULL;
PROPERTY_DEVICENAME->rtti = RTTI_PROPERTY;
PROPERTY_DEVICENAME->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_DEVICENAME);

#endif
#if INCLUDE_PROPERTY_MAXVOLUME

PROPERTY_MAXVOLUME =  (property_t *) malloc(sizeof(property_t));
PROPERTY_MAXVOLUME->name = strdup("MaxVolume");
PROPERTY_MAXVOLUME->about = strdup("#MaxVolume");
//PROPERTY_MAXVOLUME->range = "http://www.w3.org/2001/XMLSchema#nonNegativeInteger"; //getRange
PROPERTY_MAXVOLUME->domain = strdup("#MediaDevice"); 
PROPERTY_MAXVOLUME->maxcardinality = -1;
PROPERTY_MAXVOLUME->mincardinality = -1;
PROPERTY_MAXVOLUME->subpropertyof = NULL;
PROPERTY_MAXVOLUME->rtti = RTTI_PROPERTY;
PROPERTY_MAXVOLUME->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_MAXVOLUME);

#endif
#if INCLUDE_PROPERTY_CHANNELNAME

PROPERTY_CHANNELNAME =  (property_t *) malloc(sizeof(property_t));
PROPERTY_CHANNELNAME->name = strdup("ChannelName");
PROPERTY_CHANNELNAME->about = strdup("#ChannelName");
//PROPERTY_CHANNELNAME->range = "http://www.w3.org/2001/XMLSchema#string"; //getRange
PROPERTY_CHANNELNAME->domain = strdup("#TV"); 
PROPERTY_CHANNELNAME->maxcardinality = -1;
PROPERTY_CHANNELNAME->mincardinality = -1;
PROPERTY_CHANNELNAME->subpropertyof = NULL;
PROPERTY_CHANNELNAME->rtti = RTTI_PROPERTY;
PROPERTY_CHANNELNAME->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_CHANNELNAME);

#endif
#if INCLUDE_PROPERTY_SONGNAME

PROPERTY_SONGNAME =  (property_t *) malloc(sizeof(property_t));
PROPERTY_SONGNAME->name = strdup("songName");
PROPERTY_SONGNAME->about = strdup("#songName");
//PROPERTY_SONGNAME->range = "http://www.w3.org/2001/XMLSchema#string"; //getRange
PROPERTY_SONGNAME->domain = strdup("#AudioPlayer"); 
PROPERTY_SONGNAME->maxcardinality = -1;
PROPERTY_SONGNAME->mincardinality = -1;
PROPERTY_SONGNAME->subpropertyof = NULL;
PROPERTY_SONGNAME->rtti = RTTI_PROPERTY;
PROPERTY_SONGNAME->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_SONGNAME);

#endif
#if INCLUDE_PROPERTY_SONGNUM

PROPERTY_SONGNUM =  (property_t *) malloc(sizeof(property_t));
PROPERTY_SONGNUM->name = strdup("songNum");
PROPERTY_SONGNUM->about = strdup("#songNum");
//PROPERTY_SONGNUM->range = "http://www.w3.org/2001/XMLSchema#nonNegativeInteger"; //getRange
PROPERTY_SONGNUM->domain = strdup("#AudioPlayer"); 
PROPERTY_SONGNUM->maxcardinality = -1;
PROPERTY_SONGNUM->mincardinality = -1;
PROPERTY_SONGNUM->subpropertyof = NULL;
PROPERTY_SONGNUM->rtti = RTTI_PROPERTY;
PROPERTY_SONGNUM->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_SONGNUM);

#endif
#if INCLUDE_PROPERTY_HASMISSEDCALLS

PROPERTY_HASMISSEDCALLS =  (property_t *) malloc(sizeof(property_t));
PROPERTY_HASMISSEDCALLS->name = strdup("hasMissedCalls");
PROPERTY_HASMISSEDCALLS->about = strdup("#hasMissedCalls");
//PROPERTY_HASMISSEDCALLS->range = "http://www.w3.org/2001/XMLSchema#boolean"; //getRange
PROPERTY_HASMISSEDCALLS->domain = strdup("#MobilePhone"); 
PROPERTY_HASMISSEDCALLS->maxcardinality = -1;
PROPERTY_HASMISSEDCALLS->mincardinality = -1;
PROPERTY_HASMISSEDCALLS->subpropertyof = NULL;
PROPERTY_HASMISSEDCALLS->rtti = RTTI_PROPERTY;
PROPERTY_HASMISSEDCALLS->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_HASMISSEDCALLS);

#endif
#if INCLUDE_PROPERTY_ISCALLING

PROPERTY_ISCALLING =  (property_t *) malloc(sizeof(property_t));
PROPERTY_ISCALLING->name = strdup("isCalling");
PROPERTY_ISCALLING->about = strdup("#isCalling");
//PROPERTY_ISCALLING->range = "http://www.w3.org/2001/XMLSchema#boolean"; //getRange
PROPERTY_ISCALLING->domain = strdup("#MobilePhone"); 
PROPERTY_ISCALLING->maxcardinality = -1;
PROPERTY_ISCALLING->mincardinality = -1;
PROPERTY_ISCALLING->subpropertyof = NULL;
PROPERTY_ISCALLING->rtti = RTTI_PROPERTY;
PROPERTY_ISCALLING->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_ISCALLING);

#endif
#if INCLUDE_PROPERTY_ISVOLUMEON

PROPERTY_ISVOLUMEON =  (property_t *) malloc(sizeof(property_t));
PROPERTY_ISVOLUMEON->name = strdup("isVolumeOn");
PROPERTY_ISVOLUMEON->about = strdup("#isVolumeOn");
//PROPERTY_ISVOLUMEON->range = "http://www.w3.org/2001/XMLSchema#boolean"; //getRange
PROPERTY_ISVOLUMEON->domain = strdup("#MediaDevice"); 
PROPERTY_ISVOLUMEON->maxcardinality = -1;
PROPERTY_ISVOLUMEON->mincardinality = -1;
PROPERTY_ISVOLUMEON->subpropertyof = NULL;
PROPERTY_ISVOLUMEON->rtti = RTTI_PROPERTY;
PROPERTY_ISVOLUMEON->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_ISVOLUMEON);

#endif
#if INCLUDE_PROPERTY_CURRENTVOLUME

PROPERTY_CURRENTVOLUME =  (property_t *) malloc(sizeof(property_t));
PROPERTY_CURRENTVOLUME->name = strdup("CurrentVolume");
PROPERTY_CURRENTVOLUME->about = strdup("#CurrentVolume");
//PROPERTY_CURRENTVOLUME->range = "http://www.w3.org/2001/XMLSchema#nonNegativeInteger"; //getRange
PROPERTY_CURRENTVOLUME->domain = strdup("#MediaDevice"); 
PROPERTY_CURRENTVOLUME->maxcardinality = -1;
PROPERTY_CURRENTVOLUME->mincardinality = -1;
PROPERTY_CURRENTVOLUME->subpropertyof = NULL;
PROPERTY_CURRENTVOLUME->rtti = RTTI_PROPERTY;
PROPERTY_CURRENTVOLUME->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_CURRENTVOLUME);

#endif
#if INCLUDE_PROPERTY_MANUFACTURER

PROPERTY_MANUFACTURER =  (property_t *) malloc(sizeof(property_t));
PROPERTY_MANUFACTURER->name = strdup("Manufacturer");
PROPERTY_MANUFACTURER->about = strdup("#Manufacturer");
//PROPERTY_MANUFACTURER->range = "http://www.w3.org/2001/XMLSchema#string"; //getRange
PROPERTY_MANUFACTURER->domain = strdup("#Device"); 
PROPERTY_MANUFACTURER->maxcardinality = -1;
PROPERTY_MANUFACTURER->mincardinality = -1;
PROPERTY_MANUFACTURER->subpropertyof = NULL;
PROPERTY_MANUFACTURER->rtti = RTTI_PROPERTY;
PROPERTY_MANUFACTURER->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_MANUFACTURER);

#endif
#if INCLUDE_PROPERTY_RESOLUTION

PROPERTY_RESOLUTION =  (property_t *) malloc(sizeof(property_t));
PROPERTY_RESOLUTION->name = strdup("Resolution");
PROPERTY_RESOLUTION->about = strdup("#Resolution");
//PROPERTY_RESOLUTION->range = "http://www.w3.org/2001/XMLSchema#string"; //getRange
PROPERTY_RESOLUTION->domain = strdup("#VideoDevice"); 
PROPERTY_RESOLUTION->maxcardinality = -1;
PROPERTY_RESOLUTION->mincardinality = -1;
PROPERTY_RESOLUTION->subpropertyof = NULL;
PROPERTY_RESOLUTION->rtti = RTTI_PROPERTY;
PROPERTY_RESOLUTION->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_RESOLUTION);

#endif
#if INCLUDE_PROPERTY_CHANNEL

PROPERTY_CHANNEL =  (property_t *) malloc(sizeof(property_t));
PROPERTY_CHANNEL->name = strdup("Channel");
PROPERTY_CHANNEL->about = strdup("#Channel");
//PROPERTY_CHANNEL->range = "http://www.w3.org/2001/XMLSchema#nonNegativeInteger"; //getRange
PROPERTY_CHANNEL->domain = strdup("#TV"); 
PROPERTY_CHANNEL->maxcardinality = -1;
PROPERTY_CHANNEL->mincardinality = -1;
PROPERTY_CHANNEL->subpropertyof = NULL;
PROPERTY_CHANNEL->rtti = RTTI_PROPERTY;
PROPERTY_CHANNEL->type = DATATYPEPROPERTY;

add_entity_to_repository((void *) PROPERTY_CHANNEL);

#endif




#if INCLUDE_CLASS_VIDEODEVICE

CLASS_VIDEODEVICE = (class_t *) malloc(sizeof(class_t));
CLASS_VIDEODEVICE->rtti = RTTI_CLASS;
CLASS_VIDEODEVICE->classtype =  strdup("#VideoDevice");
CLASS_VIDEODEVICE->properties = list_get_new_list();  
CLASS_VIDEODEVICE->instances = NULL;
CLASS_VIDEODEVICE->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_VIDEODEVICE);

#if INCLUDE_PROPERTY_RESOLUTION
tmp_node = list_get_new_node(PROPERTY_RESOLUTION);
list_add_node(tmp_node, CLASS_VIDEODEVICE->properties);
#endif
#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_VIDEODEVICE->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_VIDEODEVICE->properties);
#endif

#endif
#if INCLUDE_CLASS_MOBILEPHONE

CLASS_MOBILEPHONE = (class_t *) malloc(sizeof(class_t));
CLASS_MOBILEPHONE->rtti = RTTI_CLASS;
CLASS_MOBILEPHONE->classtype =  strdup("#MobilePhone");
CLASS_MOBILEPHONE->properties = list_get_new_list();  
CLASS_MOBILEPHONE->instances = NULL;
CLASS_MOBILEPHONE->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_MOBILEPHONE);

#if INCLUDE_PROPERTY_ISVOLUMEON
tmp_node = list_get_new_node(PROPERTY_ISVOLUMEON);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_MAXVOLUME
tmp_node = list_get_new_node(PROPERTY_MAXVOLUME);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_SONGNAME
tmp_node = list_get_new_node(PROPERTY_SONGNAME);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_CURRENTVOLUME
tmp_node = list_get_new_node(PROPERTY_CURRENTVOLUME);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_HASMISSEDCALLS
tmp_node = list_get_new_node(PROPERTY_HASMISSEDCALLS);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_SONGNUM
tmp_node = list_get_new_node(PROPERTY_SONGNUM);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif
#if INCLUDE_PROPERTY_ISCALLING
tmp_node = list_get_new_node(PROPERTY_ISCALLING);
list_add_node(tmp_node, CLASS_MOBILEPHONE->properties);
#endif

#endif
#if INCLUDE_CLASS_AUDIOPLAYER

CLASS_AUDIOPLAYER = (class_t *) malloc(sizeof(class_t));
CLASS_AUDIOPLAYER->rtti = RTTI_CLASS;
CLASS_AUDIOPLAYER->classtype =  strdup("#AudioPlayer");
CLASS_AUDIOPLAYER->properties = list_get_new_list();  
CLASS_AUDIOPLAYER->instances = NULL;
CLASS_AUDIOPLAYER->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_AUDIOPLAYER);

#if INCLUDE_PROPERTY_SONGNAME
tmp_node = list_get_new_node(PROPERTY_SONGNAME);
list_add_node(tmp_node, CLASS_AUDIOPLAYER->properties);
#endif
#if INCLUDE_PROPERTY_SONGNUM
tmp_node = list_get_new_node(PROPERTY_SONGNUM);
list_add_node(tmp_node, CLASS_AUDIOPLAYER->properties);
#endif
#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_AUDIOPLAYER->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_AUDIOPLAYER->properties);
#endif

#endif
#if INCLUDE_CLASS_NOTHING

CLASS_NOTHING = (class_t *) malloc(sizeof(class_t));
CLASS_NOTHING->rtti = RTTI_CLASS;
CLASS_NOTHING->classtype =  strdup("http://www.w3.org/2002/07/owl#Nothing");
CLASS_NOTHING->properties = list_get_new_list();  
CLASS_NOTHING->instances = NULL;
CLASS_NOTHING->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_NOTHING);

#if INCLUDE_PROPERTY_RESOLUTION
tmp_node = list_get_new_node(PROPERTY_RESOLUTION);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_ISVOLUMEON
tmp_node = list_get_new_node(PROPERTY_ISVOLUMEON);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_MAXVOLUME
tmp_node = list_get_new_node(PROPERTY_MAXVOLUME);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_SONGNAME
tmp_node = list_get_new_node(PROPERTY_SONGNAME);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_CHANNELNAME
tmp_node = list_get_new_node(PROPERTY_CHANNELNAME);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_CURRENTVOLUME
tmp_node = list_get_new_node(PROPERTY_CURRENTVOLUME);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_HASMISSEDCALLS
tmp_node = list_get_new_node(PROPERTY_HASMISSEDCALLS);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_SONGNUM
tmp_node = list_get_new_node(PROPERTY_SONGNUM);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_CHANNEL
tmp_node = list_get_new_node(PROPERTY_CHANNEL);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif
#if INCLUDE_PROPERTY_ISCALLING
tmp_node = list_get_new_node(PROPERTY_ISCALLING);
list_add_node(tmp_node, CLASS_NOTHING->properties);
#endif

#endif
#if INCLUDE_CLASS_THING

CLASS_THING = (class_t *) malloc(sizeof(class_t));
CLASS_THING->rtti = RTTI_CLASS;
CLASS_THING->classtype =  strdup("http://www.w3.org/2002/07/owl#Thing");
CLASS_THING->properties = list_get_new_list();  
CLASS_THING->instances = NULL;
CLASS_THING->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_THING);


#endif
#if INCLUDE_CLASS_DEVICE

CLASS_DEVICE = (class_t *) malloc(sizeof(class_t));
CLASS_DEVICE->rtti = RTTI_CLASS;
CLASS_DEVICE->classtype =  strdup("#Device");
CLASS_DEVICE->properties = list_get_new_list();  
CLASS_DEVICE->instances = NULL;
CLASS_DEVICE->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_DEVICE);

#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_DEVICE->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_DEVICE->properties);
#endif

#endif
#if INCLUDE_CLASS_MEDIADEVICE

CLASS_MEDIADEVICE = (class_t *) malloc(sizeof(class_t));
CLASS_MEDIADEVICE->rtti = RTTI_CLASS;
CLASS_MEDIADEVICE->classtype =  strdup("#MediaDevice");
CLASS_MEDIADEVICE->properties = list_get_new_list();  
CLASS_MEDIADEVICE->instances = NULL;
CLASS_MEDIADEVICE->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_MEDIADEVICE);

#if INCLUDE_PROPERTY_ISVOLUMEON
tmp_node = list_get_new_node(PROPERTY_ISVOLUMEON);
list_add_node(tmp_node, CLASS_MEDIADEVICE->properties);
#endif
#if INCLUDE_PROPERTY_MAXVOLUME
tmp_node = list_get_new_node(PROPERTY_MAXVOLUME);
list_add_node(tmp_node, CLASS_MEDIADEVICE->properties);
#endif
#if INCLUDE_PROPERTY_CURRENTVOLUME
tmp_node = list_get_new_node(PROPERTY_CURRENTVOLUME);
list_add_node(tmp_node, CLASS_MEDIADEVICE->properties);
#endif
#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_MEDIADEVICE->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_MEDIADEVICE->properties);
#endif

#endif
#if INCLUDE_CLASS_TV

CLASS_TV = (class_t *) malloc(sizeof(class_t));
CLASS_TV->rtti = RTTI_CLASS;
CLASS_TV->classtype =  strdup("#TV");
CLASS_TV->properties = list_get_new_list();  
CLASS_TV->instances = NULL;
CLASS_TV->superclasses = list_get_new_list();  

add_entity_to_repository((void *) CLASS_TV);

#if INCLUDE_PROPERTY_RESOLUTION
tmp_node = list_get_new_node(PROPERTY_RESOLUTION);
list_add_node(tmp_node, CLASS_TV->properties);
#endif
#if INCLUDE_PROPERTY_CHANNELNAME
tmp_node = list_get_new_node(PROPERTY_CHANNELNAME);
list_add_node(tmp_node, CLASS_TV->properties);
#endif
#if INCLUDE_PROPERTY_MANUFACTURER
tmp_node = list_get_new_node(PROPERTY_MANUFACTURER);
list_add_node(tmp_node, CLASS_TV->properties);
#endif
#if INCLUDE_PROPERTY_CHANNEL
tmp_node = list_get_new_node(PROPERTY_CHANNEL);
list_add_node(tmp_node, CLASS_TV->properties);
#endif
#if INCLUDE_PROPERTY_DEVICENAME
tmp_node = list_get_new_node(PROPERTY_DEVICENAME);
list_add_node(tmp_node, CLASS_TV->properties);
#endif

#endif


#if INCLUDE_CLASS_VIDEODEVICE
#if INCLUDE_CLASS_DEVICE
tmp_node = list_get_new_node(CLASS_DEVICE);
list_add_node(tmp_node, CLASS_VIDEODEVICE->superclasses);
#endif
#endif
#if INCLUDE_CLASS_MOBILEPHONE
#if INCLUDE_CLASS_AUDIOPLAYER
tmp_node = list_get_new_node(CLASS_AUDIOPLAYER);
list_add_node(tmp_node, CLASS_MOBILEPHONE->superclasses);
#endif
#endif
#if INCLUDE_CLASS_MOBILEPHONE
#if INCLUDE_CLASS_MEDIADEVICE
tmp_node = list_get_new_node(CLASS_MEDIADEVICE);
list_add_node(tmp_node, CLASS_MOBILEPHONE->superclasses);
#endif
#endif
#if INCLUDE_CLASS_AUDIOPLAYER
#if INCLUDE_CLASS_DEVICE
tmp_node = list_get_new_node(CLASS_DEVICE);
list_add_node(tmp_node, CLASS_AUDIOPLAYER->superclasses);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_MOBILEPHONE
tmp_node = list_get_new_node(CLASS_MOBILEPHONE);
list_add_node(tmp_node, CLASS_NOTHING->superclasses);
#endif
#endif
#if INCLUDE_CLASS_NOTHING
#if INCLUDE_CLASS_TV
tmp_node = list_get_new_node(CLASS_TV);
list_add_node(tmp_node, CLASS_NOTHING->superclasses);
#endif
#endif
#if INCLUDE_CLASS_DEVICE
#if INCLUDE_CLASS_THING
tmp_node = list_get_new_node(CLASS_THING);
list_add_node(tmp_node, CLASS_DEVICE->superclasses);
#endif
#endif
#if INCLUDE_CLASS_MEDIADEVICE
#if INCLUDE_CLASS_DEVICE
tmp_node = list_get_new_node(CLASS_DEVICE);
list_add_node(tmp_node, CLASS_MEDIADEVICE->superclasses);
#endif
#endif
#if INCLUDE_CLASS_TV
#if INCLUDE_CLASS_VIDEODEVICE
tmp_node = list_get_new_node(CLASS_VIDEODEVICE);
list_add_node(tmp_node, CLASS_TV->superclasses);
#endif
#endif



}


